%A simple example of the performance of PCA

%Datos
X=[0.5 0.5; 0.6 0.7; 0.7 0.6; 0.78 0.77; 0.67 0.54; 0.4 0.9;
0.43 0.98; 0.38 1; 0.42 0.9; 0.7 0.6; 0.75 0.6; 0.85 0.4;0.6 0.9; 0.9 0.8; 1 1; 0.8 1.1;  1.2 0.75 ;1.4 1.2;1.5 1.4;1.5 1; 2 1; 2 1.3; 1.25 1.2
0.8 0.9;1 0.9; 1.2 1; 1.2 1.1;1.4 1.1;1.4 1;1.2 0.9; 1.6 1.2; 0.6 0.8; 0.8 1;0.9 0.95;1.1 0.95;1 0.8;0.5 0.7;0.7 0.85;
1.6 1.1; 1.4 1.3;1.65 1.3; 1.7 1.35]';


%each column is an example (a 2D point)
N=size(X,2); %number of examples
M=size(X,1); %dimension of each example

meanX=mean(X,2); %mean
Xm=X-meanX*ones(1,N); %centering the data
C=(Xm*Xm')/N; %covariance matrix
[U D]=eig(C); %computing the eigenspace: U is the matrix where the columns are the eigenvectors and D has the eigenvalues

P=U'*Xm; %projecting the centered data over the eigenspace

figure(100)
hold on
plot(X(1,:),X(2,:),'ko')   %original data
plot(Xm(1,:),Xm(2,:),'ro')  %centered data
plot(P(1,:),P(2,:),'b*') %projected data

legend('original','centered','uncorrelated')

% 2  principal axis (the eigenvalues are in increasing order)
h=plot([0, 0.5*U(1,1) ],[0 0.5*U(2,1)],'-r');
    set(h,'LineWidth', 1.5);
h=plot([0, -0.5*U(1,1) ],[0 -0.5*U(2,1)],'-r');
    set(h,'LineWidth', 1.5);

% 1 principal axis
h=plot([0, U(1,2) ],[0 U(2,2)],'-r');
    set(h,'LineWidth', 1.5);
h=plot([0, -U(1,2) ],[0 -U(2,2)],'-r');
    set(h,'LineWidth', 1.5);

    
    
[V D]=eig(P*P'); %cartesian vectors  

h=plot([0, 0.5*V(1,1) ],[0 0.5*V(2,1)],'--b');
    set(h,'LineWidth', 1.5);
h=plot([0, -0.5*V(1,1) ],[0 -0.5*V(2,1)],'--b');
    set(h,'LineWidth', 1.5);

h=plot([0, V(1,2) ],[0 V(2,2)],'--b');
    set(h,'LineWidth', 1.5);
h=plot([0, -V(1,2) ],[0 -V(2,2)],'--b');
    set(h,'LineWidth', 1.5);

    
axis([-1 2.5 -1.5 2]);
axis equal;
grid;



%%