
function [p1,p2,p3,p4,p5,p6,p7,p8]=ORL_faces(Nv,display)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Face recognition system based on PCA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Nv= number of eiegenvectors (dimension of the eigenespace)
%display ==1 show the graphics display==0 doesnt show the graphics
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
N=8 %number of members of the face recognition system

if Nv > N
    error('Number of eigenvector must be lower that the number of classes')
end
if display ==1
    if Nv<3
        error ('If you want to see the graphics, you must select Nv >= 3')
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%Faces used to generate the PCA transformation
x1=imread('orl-faces/s1/1.pgm');
x2=imread('orl-faces/s2/1.pgm');
x3=imread('orl-faces/s3/1.pgm');
x4=imread('orl-faces/s4/1.pgm');
x5=imread('orl-faces/s5/1.pgm');
x6=imread('orl-faces/s6/1.pgm');
x7=imread('orl-faces/s7/1.pgm');
x8=imread('orl-faces/s8/1.pgm');


for i=1:N
comando=sprintf('x%d=x%d(:);',i,i);
eval(comando);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%data matrix
X=[x1 x2 x3 x4 x5 x6 x7 x8]; %each column is a face
X=double(X);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%% PCA 
[V,D,Average] = pc_evectors(X,Nv);


for i = 1:N
    Xm(:,i) = X(:,i) - Average; %centering the data
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%projecting the data on the eigenspace
p=V'*Xm; 




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Projecting the rest of the images on the eigenspace
for num_face=1:N
    
for i=1:10
    file_test=sprintf('orl-faces/s%d/%d.pgm',num_face,i);
    comando=sprintf('t%d=imread(file_test);',i);
    eval(comando);
    comando=sprintf('t%d=t%d(:);',i,i);
    eval(comando);
end

T=[t1 t2 t3 t4 t5 t6 t7 t8 t9 t10]; %each column is a face
T=double(T);

for i = 1:10
    Tm(:,i) = T(:,i) - Average; %centering 
end;


proy=V'*Tm;

comando=sprintf('p%d=proy;',num_face);%The variables p1, p2,... p8 are the projections of the faces
eval(comando);

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Visualization of the projections

if display==1

c1=1; % the first 3 dimensions
c2=2;
c3=3;

%3D graphics
figure
plot3(p1(c1,:),p1(c2,:),p1(c3,:),'b*')
hold on
plot3(p2(c1,:),p2(c2,:),p2(c3,:),'g*')
plot3(p3(c1,:),p3(c2,:),p3(c3,:),'r*')
plot3(p4(c1,:),p4(c2,:),p4(c3,:),'c*')
plot3(p5(c1,:),p5(c2,:),p5(c3,:),'m*')
plot3(p6(c1,:),p6(c2,:),p6(c3,:),'y*')
plot3(p7(c1,:),p7(c2,:),p7(c3,:),'bo')
plot3(p8(c1,:),p8(c2,:),p8(c3,:),'go')
grid
legend('face1','face2','face3','face4','face5','face6','face7','face8')



%2D graphics
figure
plot(p1(c1,:),p1(c2,:),'b*')
hold on
plot(p2(c1,:),p2(c2,:),'g*')
plot(p3(c1,:),p3(c2,:),'r*')
plot(p4(c1,:),p4(c2,:),'c*')
plot(p5(c1,:),p5(c2,:),'m*')
plot(p6(c1,:),p6(c2,:),'y*')
plot(p7(c1,:),p7(c2,:),'bo')
plot(p8(c1,:),p8(c2,:),'go')
grid
legend('face1','face2','face3','face4','face5','face6','face7','face8')



end