
function class=classifier(p1,p2,p3,p4,p5,p6,p7,p8,new_point,N_train,display)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%classifier --> compute the euclidean distance of the new_point to the class means
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%p1,p2,p3,p4,p5,p6,p7,p8 --> the projections of the faces on the eigenspace
%new_point --> new projection, we want to classify it
%N_train --> number of training images
%display ==1 show the graphics display==0 doesnt show the graphics
%class -->  the result of the new_point classification
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
close all 
N=8; %number of members of the face recognition system


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Averages (means) of each class
% Each average is obtained with 5 faces (the training set)
for i=1:N
    comando=sprintf('average_%d=mean(p%d(:,1:N_train),2);',i,i);
    eval(comando)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Distance of the new_point to each average
for i=1:N
       comando=sprintf('d(%d)=norm(new_point-average_%d);',i,i);
       eval(comando);
end
   
[dist class]=min(d);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Visualization

if display
    
figure(1)
c1=1; %%%%%%%% 2 dimensions
c2=2;
%%%%%%%%%projections
plot(p1(c1,1:N_train),p1(c2,1:N_train),'b*')
hold on
plot(p2(c1,1:N_train),p2(c2,1:N_train),'g*')
plot(p3(c1,1:N_train),p3(c2,1:N_train),'r*')
plot(p4(c1,1:N_train),p4(c2,1:N_train),'c*')
plot(p5(c1,1:N_train),p5(c2,1:N_train),'m*')
plot(p6(c1,1:N_train),p6(c2,1:N_train),'y*')
plot(p7(c1,1:N_train),p7(c2,1:N_train),'bo')
plot(p8(c1,1:N_train),p8(c2,1:N_train),'go')

grid
legend('face1','face2','face3','face4','face5','face6','face7','face8')
title('Projections of the training set of faces')

figure(2)
%%%%%%%%%averages
h=plot(average_1(c1,:),average_1(c2,:),'b*');
set(h,'LineWidth',5);
hold on
h=plot(average_2(c1,:),average_2(c2,:),'g*');
set(h,'LineWidth',5);
h=plot(average_3(c1,:),average_3(c2,:),'r*');
set(h,'LineWidth',5);
h=plot(average_4(c1,:),average_4(c2,:),'c*');
set(h,'LineWidth',5);
h=plot(average_5(c1,:),average_5(c2,:),'m*');
set(h,'LineWidth',5);
h=plot(average_6(c1,:),average_6(c2,:),'y*');
set(h,'LineWidth',5);
h=plot(average_7(c1,:),average_7(c2,:),'bo');
set(h,'LineWidth',5);
h=plot(average_8(c1,:),average_8(c2,:),'go');
set(h,'LineWidth',5);
title('Averages')
%%%%%%%  new_point to classify
h=plot(new_point(c1,:),new_point(c2,:),'ks');
set(h,'LineWidth',5);
grid
legend('face1','face2','face3','face4','face5','face6','face7','face8')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


figure(3)%%%all together
%%%%%%%%%projections
plot(p1(c1,1:N_train),p1(c2,1:N_train),'b*')
hold on
plot(p2(c1,1:N_train),p2(c2,1:N_train),'g*')
plot(p3(c1,1:N_train),p3(c2,1:N_train),'r*')
plot(p4(c1,1:N_train),p4(c2,1:N_train),'c*')
plot(p5(c1,1:N_train),p5(c2,1:N_train),'m*')
plot(p6(c1,1:N_train),p6(c2,1:N_train),'y*')
plot(p7(c1,1:N_train),p7(c2,1:N_train),'bo')
plot(p8(c1,1:N_train),p8(c2,1:N_train),'go')

grid
%%%%%%%%%averages
h=plot(average_1(c1,:),average_1(c2,:),'b*');
set(h,'LineWidth',5);
h=plot(average_2(c1,:),average_2(c2,:),'g*');
set(h,'LineWidth',5);
h=plot(average_3(c1,:),average_3(c2,:),'r*');
set(h,'LineWidth',5);
h=plot(average_4(c1,:),average_4(c2,:),'c*');
set(h,'LineWidth',5);
h=plot(average_5(c1,:),average_5(c2,:),'m*');
set(h,'LineWidth',5);
h=plot(average_6(c1,:),average_6(c2,:),'y*');
set(h,'LineWidth',5);
h=plot(average_7(c1,:),average_7(c2,:),'bo');
set(h,'LineWidth',5);
h=plot(average_8(c1,:),average_8(c2,:),'go');
set(h,'LineWidth',5);


%%%%%%%  new_point to classify
h=plot(new_point(c1,:),new_point(c2,:),'ks');
set(h,'LineWidth',5);


end

